COPYRIGHT = [[




      Script Version: 1.0
      Copyright 2014-2015 by Alex2009(www.Alex2009.de)

      Dieses Werk bzw. Inhalt von Alex2009 ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Keine Bearbeitung 3.0 Unported Lizenz. 
      Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-nc-nd/3.0/deed.de
      ueber diese Lizenz hinausgehende Erlaubnisse koennen Sie unter http://www.Alex2009.de erhalten.




]]

local rollScriptBrake = 0.1527;
local handBrakeModDir = g_currentModDirectory;
local oldDrivableLoadBackup = Drivable.load;
Drivable.load = function(self,xmlFile)
    oldDrivableLoadBackup(self,xmlFile);
    self.handbrakeBackupForce = self.motor.brakeForce;
    self.handbrake = true;
    self.handbrakeSoundPlay = false;
	self.kmhIsNull = false;
    self.handbrakeOverlay = Overlay:new("overlayHandBrake", Utils.getFilename("handbrake.dds", handBrakeModDir), 0.83,0.07,0.02,0.016);
    self.handbrakeWarning = Overlay:new("overlayHandBrake", Utils.getFilename("handbrakeWarning.dds", handBrakeModDir),0,0,1,1);
    self.handbrakeSound = createSample("handbrakeSound")
    loadSample(self.handbrakeSound,Utils.getFilename("handbrakeWarning.wav", handBrakeModDir),false);
    self.handbrakePull = createSample("handbrakePull")
    loadSample(self.handbrakePull,Utils.getFilename("handbrakePull.wav", handBrakeModDir),false);
    self.handbrakeRelease = createSample("handbrakeRelease")
    loadSample(self.handbrakeRelease,Utils.getFilename("handbrakeRelease.wav", handBrakeModDir),false);

	g_currentMission.rollScriptHelp = true;
end;

local oldDrivableDrawBackup = Drivable.draw;
Drivable.draw = function(self)
    oldDrivableDrawBackup(self);
    if self.handbrake then
        if not (g_currentMission.driveControl ~= nil and g_currentMission.driveControl.useModules ~= nil and g_currentMission.driveControl.useModules.handBrake ~= nil and g_currentMission.driveControl.useModules.handBrake and self.driveControl ~= nil and self.driveControl.handBrake ~= nil and self.driveControl.handBrake.isActive ~= nil) then
            self.handbrakeOverlay:render();
        end;
    end;
    if self.handbrakeSoundPlay then
        self.handbrakeWarning:render();
    end;
end;

local oldDriveableLeaveBackup = Drivable.onLeave;
Drivable.onLeave = function(self)
    oldDriveableLeaveBackup(self);
    if self.handbrakeSoundPlay then
        stopSample(self.handbrakeSound);
        self.handbrakeSoundPlay = false;
    end;
    if not self.handbrake and self.isServer then
        for _, wheel in pairs(self.wheels) do
            setWheelShapeProps(wheel.node, wheel.wheelShape, 0, (getMass(self.components[1].node)*rollScriptBrake), wheel.steeringAngle)
        end
        for _, implement in pairs(self.attachedImplements) do
            if implement.object.wheels ~= nil then
                for _, wheel in pairs(implement.object.wheels) do
                  setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0, wheel.steeringAngle)
                end;
            end;
        end;
    end;
end;

local oldDriveableUpdateBackup = Drivable.update;
Drivable.update = function(self,dt)
    oldDriveableUpdateBackup(self,dt);
    local driveControlModul = false;
    if g_currentMission.driveControl ~= nil and g_currentMission.driveControl.useModules ~= nil and g_currentMission.driveControl.useModules.handBrake ~= nil and g_currentMission.driveControl.useModules.handBrake then
        driveControlModul = true;
    end;
    local oldHandbrake = self.handbrake;
    if self.RLupdateWheels == nil then
        self.handbrake = true;
    end;
    if not self.isEntered and not self.isHired and not self.handbrake then
        if self.isServer and not self.isControlled then
            for _, wheel in pairs(self.wheels) do
                local axleSpeed = getWheelShapeAxleSpeed(wheel.node, wheel.wheelShape)
                WheelsUtil.updateWheelPhysics(self, wheel, false, axleSpeed, (getMass(self.components[1].node)*rollScriptBrake), 1, dt)
            end;
            for _, wheel in pairs(self.wheels) do
                setWheelShapeProps(wheel.node, wheel.wheelShape, 1, (getMass(self.components[1].node)*rollScriptBrake), wheel.steeringAngle)
            end
            for _, implement in pairs(self.attachedImplements) do
                if implement.object.wheels ~= nil then
                    for _, wheel in pairs(implement.object.wheels) do
                      setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0, wheel.steeringAngle)
                    end;
                end;
            end;
        end;
        WheelsUtil.updateWheelsGraphics(self,dt);
        for _, implement in pairs(self.attachedImplements) do
            if implement.object.wheels ~= nil then
                WheelsUtil.updateWheelsGraphics(implement.object,dt);
            end;
        end;
    elseif not self.isHired and self.isControlled then
        if self.isEntered then--
            if driveControlModul and self.driveControl ~= nil and self.driveControl.handBrake ~= nil and self.driveControl.handBrake.isActive ~= nil then
                driveControlHandbrake = true;
                if self.handbrake ~= self.driveControl.handBrake.isActive then
                    realisticRollEvent.sendEvent(self,self.driveControl.handBrake.isActive);
                end;
                self.handbrake = self.driveControl.handBrake.isActive;
            else
                if InputBinding.hasEvent(InputBinding.HANDBRAKE) then
                    self.handbrake = not self.handbrake;
                    realisticRollEvent.sendEvent(self,self.handbrake);
                    if self.handbrake then
                        playSample(self.handbrakePull,1,1,0);
                        self.handbrakeBackupForce = self.motor.brakeForce;
                        self.motor.brakeForce = 1000000;
                    else
                        playSample(self.handbrakeRelease,1,1,0);
                        if self.handbrakeSoundPlay then
                            stopSample(self.handbrakeSound);
                            self.handbrakeSoundPlay = false;
                        end;
                        self.motor.brakeForce = self.handbrakeBackupForce;
                    end;
                end;
                if InputBinding.hasEvent(InputBinding.Roll_Help_Disable) then
                    g_currentMission.rollScriptHelp = not g_currentMission.rollScriptHelp;
                end;
                if g_currentMission.rollScriptHelp ~= nil and g_currentMission.rollScriptHelp then
                    g_currentMission:addHelpButtonText(g_i18n:getText("Roll_Help_Disable"), InputBinding.Roll_Help_Disable)
                end;
                if self.handbrake then
                    if g_currentMission.rollScriptHelp ~= nil and g_currentMission.rollScriptHelp then
                        g_currentMission:addHelpButtonText(g_i18n:getText("HANDBRAKE_OPEN"), InputBinding.HANDBRAKE)
                    end;
                else
                    self.motor.brakeForce = self.handbrakeBackupForce;
                    if g_currentMission.rollScriptHelp ~= nil and g_currentMission.rollScriptHelp then
                        g_currentMission:addHelpButtonText(g_i18n:getText("HANDBRAKE_CLOSE"), InputBinding.HANDBRAKE)
                    end;
                end;
            end;
            if self.handbrake then
                if self.cruiseControl.state > 0 then
                    self:setCruiseControlState(0);
                end;
                self.motor.brakeForce = 1000000;
            end;
        end;--
        if (self.isControlled and self.isServer) or self.isEntered then--
            local kmh = math.max(0, self:getLastSpeed() * self.speedDisplayScale)
            if math.floor(g_i18n:getSpeed(kmh)) > 2 and self.handbrake then 
                if self.isEntered then
                    if not self.handbrakeSoundPlay then
                        if not (driveControlModul and self.driveControl ~= nil and self.driveControl.handBrake ~= nil and self.driveControl.handBrake.isActive ~= nil) then
                            playSample(self.handbrakeSound,0,1,0);
                            self.handbrakeSoundPlay = true;
                        end;
                    end;
                end;
            elseif math.floor(g_i18n:getSpeed(kmh)) <= 1 and not self.handbrake and self.isEntered then
                self.kmhIsNull = true;
                realisticRollEventKMH.sendEvent(self, true)
            else
                if self.isEntered then
                    if self.handbrakeSoundPlay then
                        stopSample(self.handbrakeSound);
                        self.handbrakeSoundPlay = false;
                    end;
                end;
            end;
            if self.kmhIsNull then
                if self.axisForward > 0 or self.axisForward < 0 or self.handbrake and self.isEntered then
                    self.kmhIsNull = false;
                    realisticRollEventKMH.sendEvent(self, false)
                else
                    if self.isServer then
                        for _, wheel in pairs(self.wheels) do
                            local axleSpeed = getWheelShapeAxleSpeed(wheel.node, wheel.wheelShape)
                            WheelsUtil.updateWheelPhysics(self, wheel, false, axleSpeed, (getMass(self.components[1].node)*rollScriptBrake), 10, dt)
                        end;
                        for _, wheel in pairs(self.wheels) do
                            setWheelShapeProps(wheel.node, wheel.wheelShape, 10, (getMass(self.components[1].node)*rollScriptBrake), wheel.steeringAngle)
                        end
                        for _, implement in pairs(self.attachedImplements) do
                            if implement.object.wheels ~= nil then
                                for _, wheel in pairs(implement.object.wheels) do
                                  setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0, wheel.steeringAngle)
                                end;
                            end;
                        end;
                    end;
                    WheelsUtil.updateWheelsGraphics(self,dt);
                end;
            end;
        end;--
    elseif self.isHired then
        if self.handbrake then
            realisticRollEvent.sendEvent(self,false);
        end;
        self.handbrake = false;
    end;
    if self.RLupdateWheels == nil then
        self.handbrake = oldHandbrake;
        if self.isServer then
            WheelsUtil.updateWheelsPhysics(self, 0, self.lastSpeedReal, 0, false, self.requiredDriveMode)
        end;
        self.RLupdateWheels = true;
    end;
end;

local oldDriveableUpdatevehiclePhysiks = Drivable.updateVehiclePhysics;
Drivable.updateVehiclePhysics = function(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, dt)
	if self.kmhIsNull == nil or not self.kmhIsNull then
		oldDriveableUpdatevehiclePhysiks(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, dt);
	else
	  axisSide = self.reverserDirection * axisSide
	  local inputAxisX = axisSide
	  if axisSideIsAnalog then
		local targetRotatedTime = 0
		if inputAxisX < 0 then
		  targetRotatedTime = math.min(-self.maxRotTime * inputAxisX, self.maxRotTime)
		else
		  targetRotatedTime = math.max(self.minRotTime * inputAxisX, self.minRotTime)
		end
		local maxTime = self.maxRotatedTimeSpeed * dt
		if maxTime < math.abs(targetRotatedTime - self.rotatedTime) then
		  if targetRotatedTime > self.rotatedTime then
			self.rotatedTime = self.rotatedTime + maxTime
		  else
			self.rotatedTime = self.rotatedTime - maxTime
		  end
		else
		  self.rotatedTime = targetRotatedTime
		end
	  else
		local rotScale = math.min(1 / (self.lastSpeed * self.speedRotScale + self.speedRotScaleOffset), 1)
		if inputAxisX < 0 then
		  self.rotatedTime = math.min(self.rotatedTime - dt * 0.001 * inputAxisX * rotScale, self.maxRotTime)
		elseif inputAxisX > 0 then
		  self.rotatedTime = math.max(self.rotatedTime - dt * 0.001 * inputAxisX * rotScale, self.minRotTime)
		elseif self.autoRotateBackSpeed ~= 0 then
		  if 0 < self.rotatedTime then
			self.rotatedTime = math.max(self.rotatedTime - dt * 0.001 * self.autoRotateBackSpeed * rotScale, 0)
		  else
			self.rotatedTime = math.min(self.rotatedTime + dt * 0.001 * self.autoRotateBackSpeed * rotScale, 0)
		  end
		end
	  end
	end;
end;

local oldDriveableWriteBackup = Drivable.writeStream;
Drivable.writeStream = function(self, streamId, connection)
    oldDriveableWriteBackup(self, streamId, connection);
    if self.isServer then
        streamWriteBool(streamId, self.handbrake);
    end;
end
local oldDriveableReadBackup = Drivable.readStream;
Drivable.readStream = function(self, streamId, connection)
    oldDriveableReadBackup(self, streamId, connection)
    self.handbrake = streamReadBool(streamId);
    if self.handbrake then
        self.handbrakeBackupForce = self.motor.brakeForce;
        self.motor.brakeForce = 1000000;
    else
        self.motor.brakeForce = self.handbrakeBackupForce;
    end;
    self.RLupdateWheels = nil;
end;

local oldDriveableLoadBackup = Drivable.loadFromAttributesAndNodes;
Drivable.loadFromAttributesAndNodes = function(self, xmlFile, key, resetVehicles)
  if not resetVehicles then
	self.handbrake = Utils.getNoNil(getXMLBool(xmlFile, key .. "#handbrake"),false);
  end;
  return oldDriveableLoadBackup(self, xmlFile, key, resetVehicles);
end;

local oldDriveableSaveBackup = Drivable.getSaveAttributesAndNodes;
Drivable.getSaveAttributesAndNodes = function(self, nodeIdent)
  local attr, nodes = oldDriveableSaveBackup(self, nodeIdent)
  attributes = attr.." handbrake=\""..tostring(self.handbrake).."\"";
  return attributes, nodes
end

realisticRollEvent = {};
realisticRollEvent_mt = Class(realisticRollEvent, Event);
InitEventClass(realisticRollEvent, "realisticRollEvent");
function realisticRollEvent:emptyNew()
    local self = Event:new(realisticRollEvent_mt);
    self.className="realisticRollEvent";
    return self;
end;

function realisticRollEvent:new(vehicle, handbrake)
    local self = realisticRollEvent:emptyNew()
    self.vehicle = vehicle;
    self.handbrake = handbrake;
    return self;
end;

function realisticRollEvent:readStream(streamId, connection)
    self.vehicle = networkGetObject(streamReadInt32(streamId));
    self.handbrake = streamReadBool(streamId);
    self:run(connection);
end;

function realisticRollEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
    streamWriteBool(streamId, self.handbrake);
end;

function realisticRollEvent:run(connection)
    self.vehicle.handbrake = self.handbrake;
    if self.vehicle.handbrake then
        self.vehicle.handbrakeBackupForce = self.vehicle.motor.brakeForce;
        self.vehicle.motor.brakeForce = 1000000;
    else
        self.vehicle.motor.brakeForce = self.vehicle.handbrakeBackupForce;
        self.vehicle.RLupdateWheels = nil;
    end;
    if not connection:getIsServer() then
        g_server:broadcastEvent(realisticRollEvent:new(self.vehicle, self.handbrake), nil, connection, self.vehicle);
    end;	
end;

function realisticRollEvent.sendEvent(vehicle, handbrake, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(realisticRollEvent:new(vehicle, handbrake), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(realisticRollEvent:new(vehicle, handbrake));
		end;
	end;
end;

realisticRollEventKMH = {};
realisticRollEventKMH_mt = Class(realisticRollEventKMH, Event);
InitEventClass(realisticRollEventKMH, "realisticRollEventKMH");
function realisticRollEventKMH:emptyNew()
    local self = Event:new(realisticRollEventKMH_mt);
    self.className="realisticRollEventKMH";
    return self;
end;

function realisticRollEventKMH:new(vehicle, kmhIsNull)
    local self = realisticRollEventKMH:emptyNew()
    self.vehicle = vehicle;
    self.kmhIsNull = kmhIsNull;
    return self;
end;

function realisticRollEventKMH:readStream(streamId, connection)
    self.vehicle = networkGetObject(streamReadInt32(streamId));
    self.kmhIsNull = streamReadBool(streamId);
    self:run(connection);
end;

function realisticRollEventKMH:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
    streamWriteBool(streamId, self.kmhIsNull);
end;

function realisticRollEventKMH:run(connection)
    self.vehicle.kmhIsNull = self.kmhIsNull;
    if not connection:getIsServer() then
        g_server:broadcastEvent(realisticRollEventKMH:new(self.vehicle, self.kmhIsNull), nil, connection, self.vehicle);
    end;	
end;

function realisticRollEventKMH.sendEvent(vehicle, kmhIsNull, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(realisticRollEventKMH:new(vehicle, kmhIsNull), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(realisticRollEventKMH:new(vehicle, kmhIsNull));
		end;
	end;
end;